{+--------------------------------------------------------------------------+
   Component:   Data module for Late Customisation example (uses DBDEMOS)
   Author:      Adrian Rye
 +--------------------------------------------------------------------------+}
unit uLateCustom_DM;

interface

uses
  // Delphi
  SysUtils, Classes, HTTPApp, HTTPProd, DB, DBTables;

type
  TDMLateCustom = class(TDataModule)
    tblOrders: TTable;
    tblOrdersOrderNo: TFloatField;
    tblOrdersCustNo: TFloatField;
    tblOrdersSaleDate: TDateTimeField;
    tblOrdersShipDate: TDateTimeField;
    tblOrdersEmpNo: TIntegerField;
    tblOrdersShipToContact: TStringField;
    tblOrdersShipToAddr1: TStringField;
    tblOrdersShipToAddr2: TStringField;
    tblOrdersShipToCity: TStringField;
    tblOrdersShipToState: TStringField;
    tblOrdersShipToZip: TStringField;
    tblOrdersShipToCountry: TStringField;
    tblOrdersShipToPhone: TStringField;
    tblOrdersShipVIA: TStringField;
    tblOrdersPO: TStringField;
    tblOrdersTerms: TStringField;
    tblOrdersPaymentMethod: TStringField;
    tblOrdersItemsTotal: TCurrencyField;
    tblOrdersTaxRate: TFloatField;
    tblOrdersFreight: TCurrencyField;
    tblOrdersAmountPaid: TCurrencyField;
    dsOrders: TDataSource;
    ppProperties: TPageProducer;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
    procedure ppPropertiesHTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
    procedure tblOrdersAfterScroll(DataSet: TDataSet);
  private
    FNewHint           : string;
    FNewHintProperties : string;
    FUseLateCustomisation: Boolean;
    { Private declarations }
  public
    property NewHint: string               read FNewHint              write FNewHint;
    property NewHintProperties: string     read FNewHintProperties    write FNewHintProperties;
    property UseLateCustomisation: Boolean read FUseLateCustomisation write FUseLateCustomisation;
  end;

var
  DMLateCustom: TDMLateCustom;

implementation

{$R *.dfm}


procedure TDMLateCustom.DataModuleCreate(Sender: TObject);
  begin
    tblOrders.Open;
  end;

procedure TDMLateCustom.DataModuleDestroy(Sender: TObject);
  begin
    tblOrders.Close;
  end;

procedure TDMLateCustom.ppPropertiesHTMLTag(Sender: TObject; Tag: TTag;
  const TagString: String; TagParams: TStrings; var ReplaceText: String);
  begin
    // data aware
    ReplaceText := DMLateCustom.tblOrders.FieldByName(TagString).AsString;
  end;

procedure TDMLateCustom.tblOrdersAfterScroll(DataSet: TDataSet);
  begin
    if UseLateCustomisation then begin
      // Late Customisation
      NewHint := ppProperties.ContentFromString(NewHintProperties);
    end else begin
      // Early Customisation
      NewHint := 'Order ' + tblOrdersOrderNo.AsString + #13 +
                 'Sold '  + tblOrdersSaleDate.AsString;
    end;
  end;

end.
